/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// identities - Array of identities in sip uri format.    generalCallsSubscriptions - GeneralCallsSubsriptions parameter block.    inboundCallsSubscriptions - InboundCallsSubscriptions parameter block.    outboundCallsSubscriptions - OutboundCallsSubscriptions parameter block.    mediaCallsSubscriptions - CallMediaSubscriptions parameter block.    callProgressSubscriptions - CallProgressSubscriptions parameter block.
    /// </summary>
    [DataContract]
        public partial class CallsSubscribeParams :  IEquatable<CallsSubscribeParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CallsSubscribeParams" /> class.
        /// </summary>
        /// <param name="identities">identities.</param>
        /// <param name="generalCallsSubscriptions">generalCallsSubscriptions.</param>
        /// <param name="inboundCallsSubscriptions">inboundCallsSubscriptions.</param>
        /// <param name="outboundCallsSubscriptions">outboundCallsSubscriptions.</param>
        /// <param name="mediaCallsSubscriptions">mediaCallsSubscriptions.</param>
        /// <param name="callProgressSubscriptions">callProgressSubscriptions.</param>
        public CallsSubscribeParams(List<string> identities = default(List<string>), GeneralCallsSubscriptions generalCallsSubscriptions = default(GeneralCallsSubscriptions), InboundCallsSubscriptions inboundCallsSubscriptions = default(InboundCallsSubscriptions), OutboundCallsSubscriptions outboundCallsSubscriptions = default(OutboundCallsSubscriptions), CallMediaSubscriptions mediaCallsSubscriptions = default(CallMediaSubscriptions), CallProgressSubscriptions callProgressSubscriptions = default(CallProgressSubscriptions))
        {
            this.Identities = identities;
            this.GeneralCallsSubscriptions = generalCallsSubscriptions;
            this.InboundCallsSubscriptions = inboundCallsSubscriptions;
            this.OutboundCallsSubscriptions = outboundCallsSubscriptions;
            this.MediaCallsSubscriptions = mediaCallsSubscriptions;
            this.CallProgressSubscriptions = callProgressSubscriptions;
        }
        
        /// <summary>
        /// Gets or Sets Identities
        /// </summary>
        [DataMember(Name="identities", EmitDefaultValue=false)]
        public List<string> Identities { get; set; }

        /// <summary>
        /// Gets or Sets GeneralCallsSubscriptions
        /// </summary>
        [DataMember(Name="generalCallsSubscriptions", EmitDefaultValue=false)]
        public GeneralCallsSubscriptions GeneralCallsSubscriptions { get; set; }

        /// <summary>
        /// Gets or Sets InboundCallsSubscriptions
        /// </summary>
        [DataMember(Name="inboundCallsSubscriptions", EmitDefaultValue=false)]
        public InboundCallsSubscriptions InboundCallsSubscriptions { get; set; }

        /// <summary>
        /// Gets or Sets OutboundCallsSubscriptions
        /// </summary>
        [DataMember(Name="outboundCallsSubscriptions", EmitDefaultValue=false)]
        public OutboundCallsSubscriptions OutboundCallsSubscriptions { get; set; }

        /// <summary>
        /// Gets or Sets MediaCallsSubscriptions
        /// </summary>
        [DataMember(Name="mediaCallsSubscriptions", EmitDefaultValue=false)]
        public CallMediaSubscriptions MediaCallsSubscriptions { get; set; }

        /// <summary>
        /// Gets or Sets CallProgressSubscriptions
        /// </summary>
        [DataMember(Name="callProgressSubscriptions", EmitDefaultValue=false)]
        public CallProgressSubscriptions CallProgressSubscriptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CallsSubscribeParams {\n");
            sb.Append("  Identities: ").Append(Identities).Append("\n");
            sb.Append("  GeneralCallsSubscriptions: ").Append(GeneralCallsSubscriptions).Append("\n");
            sb.Append("  InboundCallsSubscriptions: ").Append(InboundCallsSubscriptions).Append("\n");
            sb.Append("  OutboundCallsSubscriptions: ").Append(OutboundCallsSubscriptions).Append("\n");
            sb.Append("  MediaCallsSubscriptions: ").Append(MediaCallsSubscriptions).Append("\n");
            sb.Append("  CallProgressSubscriptions: ").Append(CallProgressSubscriptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CallsSubscribeParams);
        }

        /// <summary>
        /// Returns true if CallsSubscribeParams instances are equal
        /// </summary>
        /// <param name="input">Instance of CallsSubscribeParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CallsSubscribeParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Identities == input.Identities ||
                    this.Identities != null &&
                    input.Identities != null &&
                    this.Identities.SequenceEqual(input.Identities)
                ) && 
                (
                    this.GeneralCallsSubscriptions == input.GeneralCallsSubscriptions ||
                    (this.GeneralCallsSubscriptions != null &&
                    this.GeneralCallsSubscriptions.Equals(input.GeneralCallsSubscriptions))
                ) && 
                (
                    this.InboundCallsSubscriptions == input.InboundCallsSubscriptions ||
                    (this.InboundCallsSubscriptions != null &&
                    this.InboundCallsSubscriptions.Equals(input.InboundCallsSubscriptions))
                ) && 
                (
                    this.OutboundCallsSubscriptions == input.OutboundCallsSubscriptions ||
                    (this.OutboundCallsSubscriptions != null &&
                    this.OutboundCallsSubscriptions.Equals(input.OutboundCallsSubscriptions))
                ) && 
                (
                    this.MediaCallsSubscriptions == input.MediaCallsSubscriptions ||
                    (this.MediaCallsSubscriptions != null &&
                    this.MediaCallsSubscriptions.Equals(input.MediaCallsSubscriptions))
                ) && 
                (
                    this.CallProgressSubscriptions == input.CallProgressSubscriptions ||
                    (this.CallProgressSubscriptions != null &&
                    this.CallProgressSubscriptions.Equals(input.CallProgressSubscriptions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Identities != null)
                    hashCode = hashCode * 59 + this.Identities.GetHashCode();
                if (this.GeneralCallsSubscriptions != null)
                    hashCode = hashCode * 59 + this.GeneralCallsSubscriptions.GetHashCode();
                if (this.InboundCallsSubscriptions != null)
                    hashCode = hashCode * 59 + this.InboundCallsSubscriptions.GetHashCode();
                if (this.OutboundCallsSubscriptions != null)
                    hashCode = hashCode * 59 + this.OutboundCallsSubscriptions.GetHashCode();
                if (this.MediaCallsSubscriptions != null)
                    hashCode = hashCode * 59 + this.MediaCallsSubscriptions.GetHashCode();
                if (this.CallProgressSubscriptions != null)
                    hashCode = hashCode * 59 + this.CallProgressSubscriptions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
